class R { }
class E extends R { }
class B extends R { }
class G extends B { }
class U { }
public class Foo {
  public static <T> T bar(T x, T y) {
    return x;
  }
  public static void main(String[] args) {
    Object o;
    R r = new R();
    E e = new E();
    B b = new B();
    G g = new G();
    U u = new U();
    R[] x;
    E[] y;

    //insert code here
    r = bar(r,b); // kompiliert, R gemeinsamer Obertyp von R und B
    r = bar(b,r); // kompiliert, R gemeinsamer Obertyp von B und R
    r = bar(e,g); // kompiliert, R ist gemeinsamer Obertyp von E und G
    r = bar(b,g); // kompiliert, kleinster gemeinsamer Obertyp von B und G ist B ist Untertyp von R
    // e = bar(r,b); // kompiliert nicht, R als kleinster gemeinsamer Obertyp von R und B ist kein Untertyp von E
    // u = bar(u,r); // kompiliert nicht, kleinster gemeinsamer Obertyp von R und U ist Object
    o = bar(e,u); // kompiliert, Object ist kleinster gemeinsamer Obertyp von E und U
    // b = bar(e,g); // kompiliert nicht, kleinster gemeinsamer Obertyp von E und G ist kein Untertyp von B

    x = bar(new E[2], new B[4]); // kompiliert, durch Kovarianz ist R[] kleinster gemeinsamer Obertyp von E[] und G[]
                 
    // y = bar(new E[4], new B[11]); // kompiliert nicht, kleinster gemeinsamer Obertyp von E[] und B[] ist kein Untertyp von E[]
    o = bar(new G[8], new U[5]); // kompiliert, denn alle Felder sind implizit  Objekte als vom Typ Object
    /*
       siehe Java API Documentation:
       Class Object is the root of the class hierarchy.
       Every class has Object as a superclass.
       All objects, including arrays, implement the methods of this class
     */
  }
}
